/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.base;

import org.w3c.dom.Document;
import org.w3c.dom.Element;


public class ApplicationContainer extends BaseContainer {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private static ApplicationContainer _instance = null;

    private ApplicationContainer() {
        super();
    } // public ApplicationContainer()

    public synchronized CloneableObject cloneObject() {
        return null;
    } // public synchronized CloneableObject cloneObject()

    public static ApplicationContainer getInstance() {
        if (_instance == null) {
            synchronized(ApplicationContainer.class) {
                if (_instance == null) {
                    _instance = new ApplicationContainer();
                } // if (_instance == null)
            } // synchronized(ApplicationContainer.class)
        } // if (_instance == null)
        return _instance;
    } // public static ApplicationContainer getInstance()

    protected Object oneStepGetAttribute(String key) {
        ApplicationContainerItem applicationContainerItem = getApplicationContainerItem(key);
        if (applicationContainerItem == null)
            return null;
        return applicationContainerItem.getValue();
    } // protected Object oneStepGetAttribute(String key)

    public synchronized Object getAttribute(String key) {
        return oneStepGetAttribute(key);
    } // public synchronized Object getAttribute(String key)

    public synchronized void setAttribute(String key, Object value) {
        ApplicationContainerItem applicationContainerItem =
            new ApplicationContainerItem(value, ApplicationContainerItem.INFINITE_TIMEOUT);
        super.setAttribute(key, applicationContainerItem);
    } // public synchronized void setAttribute(String key, Object value)

    public synchronized void delAttribute(String key) {
        super.delAttribute(key);
    } // public synchronized void delAttribute(String key)

    public void setContainer(ApplicationContainer container) {
        return;
    } // public void setContainer(ApplicationContainer container)

    public void setParent(ApplicationContainer container) {
        return;
    } // public void setParent(ApplicationContainer container)

    private ApplicationContainerItem getApplicationContainerItem(String key) {
        return (ApplicationContainerItem)super.oneStepGetAttribute(key);
    } // private ApplicationContainerItem getApplicationContainerItem(String key)

    public synchronized Element toElement(Document document) {
        String containerName = "APPLICATION_CONTAINER";
        Element applicationContainerElement = document.createElement(containerName);
        applicationContainerElement.appendChild(super.toElement(document));
        return applicationContainerElement;
    } // public synchronized Element toElement(Document document)
} // public class ApplicationContainer extends BaseContainer
