/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess;

/**
 * Questa classe rappresenta un parametro di un pool di connessioni
 * <li> un nome
 * <li> un tipo
 * <li> un valore
 *
 * @author Andrea Zoppello 
 * @version 1.0
 */
public class ConnectionPoolParameter {
    private String _name = null;
    private String _type = null;
    private String _value = null;

    /**
    * Costruttore
    * @param <B>String</B> name  - il nome del parametro
    * @param <B>String</B> name  - il valore del parametro
    */
    public ConnectionPoolParameter(String name, String value) {
        _name = name;
        _value = value;
    } //public ConnectionPoolParameter (String name, String value)

    /**
    * Metodo getter per il parametro name
    * @return un oggetto di tipo <B>String</B> con il nome del parametro
    */
    public String getName() {
        return _name;
    } //public String getName()

    /**
    * Metodo setter per il parametro name
    * @param un oggetto di tipo <B>String</B> con il nome del parametro
    */
    public void setName(String newName) {
        _name = newName;
    } //public void setName(String newName)

    /**
    * Metodo getter per il parametro type
    * @return un oggetto di tipo <B>String</B> con il tipo del parametro
    */
    public String getType() {
        return _type;
    } //public String getType()

    /**
    * Metodo setter per il parametro type
    * @param un oggetto di tipo <B>String</B> con il tipo del parametro
    */
    public void setType(String newType) {
        _type = newType;
    } //public void setType(String newType)

    /**
    * Metodo getter per il parametro value
    * @return un oggetto di tipo <B>String</B> con il valore del parametro
    */
    public String getValue() {
        return _value;
    } //public String getValue()

    /**
    * Metodo setter per il parametro value
    * @param un oggetto di tipo <B>String</B> con il valore del parametro
    */
    public void setValue(String newValue) {
        _value = newValue;
    } //public void setValue(String newValue)
} //end Class ConnectionPoolParameter
