/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
/*
 *  Created on 1-apr-2004
 *	Project sism2
 *  
 */
package it.eng.spago.dbaccess.encript.gui;

import java.awt.Button;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import it.eng.spago.dbaccess.encript.KeyProvider;

/**
 * @author Bernabei Angelo
 * @version 1.0
 *  Interfaccia grafica AWT per la generazione del file KEY e delle password
 */
public class CriptGui  extends Frame implements ActionListener{

	/**
     * 
     */
    private static final long serialVersionUID = 1L;
    Label l_key=new Label("Key Generata (base 64)");
	Label l_psw1=new Label("Password in chiaro");
	Label l_psw2=new Label("Password cifrata");
	
	Button b_key=new Button("GenerateKey");
	Button b_psw=new Button("GeneratePassword");
	
	TextField t_key=new TextField("");
	TextField t_psw1=new TextField("Inserire la password in chiaro");
	TextField t_psw2=new TextField();
	
	TextField t_msg=new TextField();
	
	public CriptGui() {
		super();
		this.setLayout(new GridLayout(5,2));
		this.add(l_key);
		this.add(t_key);
		this.add(l_psw1);
		this.add(t_psw1);
		this.add(l_psw2);
		this.add(t_psw2);
		this.add(b_key);
		this.add(b_psw);
		this.add(t_msg);
		this.add(t_msg);
		this.pack();	
		
		b_key.addActionListener(this);
		b_psw.addActionListener(this);
		
	}
	

	
	public void actionPerformed(ActionEvent e){
		Button source= (Button)e.getSource();
		t_msg.setText("");
		if (source.getLabel().equalsIgnoreCase("GenerateKey")){

				KeyProvider kgen=new KeyProvider();
				t_key.setText(kgen.generateKey());

		}
		if (source.getLabel().equalsIgnoreCase("GeneratePassword")){
			
			if (t_psw1.getText()==null || (t_psw1.getText()!=null && t_psw1.getText().length()==0) ){
				t_msg.setText("INSERIRE LA PASSWORD DA CIFRARE");
			}else {
				t_psw2.setText(generatePsw(t_psw1.getText()));
			}
						

		}		
	}
	
	private String generatePsw(String psw) {
		PasswordGenerator algo=new PasswordGenerator();
		return algo.cifra(psw);
	}
	
	public static void main(String[] args) {
		CriptGui k=new CriptGui();
		k.setSize(450,150);
		k.show();
		
	}
}
