/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
/*
 *  Created on 26-mar-2004
 *	Project Cifratura
 *  
 */
package it.eng.spago.dbaccess.encript.gui;

import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

import it.eng.spago.dbaccess.encript.Key;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

/**
 * @author Bernabei Angelo
 * @version 1.0
 */
public class PasswordGenerator {

	private Cipher cifro=null;

	private SecretKey desKey=null;
	

	public PasswordGenerator(String key) {
		try {
			BASE64Decoder decoder= new BASE64Decoder();
			byte[] byteKey= null;
			byteKey= decoder.decodeBuffer(key);
			desKey = new SecretKeySpec(byteKey, "DES");
			cifro = Cipher.getInstance("DES/ECB/PKCS5Padding");

		} catch (NoSuchAlgorithmException e) {

			e.printStackTrace();
		} catch (NoSuchPaddingException e) {

			e.printStackTrace();
		}catch (IOException e1) {
		e1.printStackTrace();
	}
		
	}
		
	public PasswordGenerator() {
		this(Key.KEY);
	}
	
	public String cifra(String input){
		byte[] byteInput=input.getBytes();
		
		byte[] cifrata=null;

		try {

			cifro.init(Cipher.ENCRYPT_MODE,desKey);
			cifrata= cifro.doFinal(byteInput);
		} catch (InvalidKeyException e1) {

			e1.printStackTrace();
		
		} catch (IllegalStateException e) {

			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {

			e.printStackTrace();
		} catch (BadPaddingException e) {

			e.printStackTrace();
		}
	
		BASE64Encoder encoder = new BASE64Encoder();
		String base64 = encoder.encode(cifrata);
		
		return base64;
	}
	
	public String deCifra(String input){

		BASE64Decoder decoder=new BASE64Decoder();
		byte[] byteInput=null;
		try {
			byteInput= decoder.decodeBuffer(input);
		} catch (IOException e2) {
			e2.printStackTrace();
		}
		byte[] cifrata=null;
		try {

				cifro.init(Cipher.DECRYPT_MODE,desKey);

			cifrata= cifro.doFinal(byteInput);
		} catch (InvalidKeyException e1) {

			e1.printStackTrace();
		
		} catch (IllegalStateException e) {

			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {

			e.printStackTrace();
		} catch (BadPaddingException e) {

			e.printStackTrace();
		}
		
		return new String(cifrata);
	}	
	

}
