/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.hibernate;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Transaction;

public abstract class AbstractHibernateTransaction implements Transaction {
    private Transaction _nativeTransaction = null;

    public AbstractHibernateTransaction(Transaction nativeTransaction) {
        _nativeTransaction = nativeTransaction;
    } // public HibernateTransaction(Transaction nativeTransaction)

    public void commit() throws HibernateException {
        _nativeTransaction.commit();
    } // public void commit() throws HibernateException

    public void rollback() throws HibernateException {
        _nativeTransaction.rollback();
    } // public void rollback() throws HibernateException

    public boolean wasRolledBack() throws HibernateException {
        return _nativeTransaction.wasRolledBack();
    } // public boolean wasRolledBack() throws HibernateException

    public boolean wasCommitted() throws HibernateException {
        return _nativeTransaction.wasCommitted();
    } // public boolean wasCommitted() throws HibernateException
} // public abstract class AbstractHibernateTransaction implements Transaction
