/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.hibernate;

import java.sql.Connection;

import net.sf.hibernate.Session;
import net.sf.hibernate.SessionFactory;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.error.EMFInternalError;

public class HibernateSessionFactory {
    private static SessionFactory _sessionFactory = null;

    /** @link dependency 
     * @stereotype instantiate*/
    /*# Session lnkSession; */

    private HibernateSessionFactory() {
        super();
    } // private HibernateSessionFactory()

    public static void setSessionFactory(SessionFactory sessionFactory) {
        _sessionFactory = sessionFactory;
    } // public static void setSessionFactory(SessionFactory sessionFactory)

    public static Session openSession(String connectionPoolName)
        throws EMFInternalError {
        DataConnection dataConnection =
            DataConnectionManager.getInstance().getConnection(
                connectionPoolName);
        Connection connection = dataConnection.getInternalConnection();
        Session nativeSession = _sessionFactory.openSession(connection);
        HibernateSession hibernateSession = new HibernateSession(nativeSession);
        hibernateSession.setDataConnection(dataConnection);
        return hibernateSession;
    } // public static Session openSession(String connectionPoolName) throws EMFInternalError
} // public class HibernateSessionFactory
