/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.hibernate;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Transaction;

import it.eng.spago.base.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.tracing.TracerSingleton;

public class HibernateTransaction extends AbstractHibernateTransaction {
    public HibernateTransaction(Transaction nativeTransaction) {
        super(nativeTransaction);
    } // public HibernateTransaction(Transaction nativeTransaction)

    public void commit() throws HibernateException {
        if (isRequestDistributed()) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.WARNING,
                "HibernateTransaction::commit: transazione distribuita !");
            return;
        } // if (isRequestDistributed())
        super.commit();
    } // public void commit() throws HibernateException

    public void rollback() throws HibernateException {
        if (isRequestDistributed()) {
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.WARNING,
                "HibernateTransaction::rollback: transazione distribuita !");
            return;
        } // if (isRequestDistributed())
        super.rollback();
    } // public void rollback() throws HibernateException

    private boolean isRequestDistributed() {
        boolean distributedBoolean = false;
        RequestContainer requestContainer =
            RequestContainer.getRequestContainer();
        if (requestContainer != null)
            distributedBoolean = requestContainer.isRequestDistributed();
        return distributedBoolean;
    } // private boolean isRequestDistributed()
} // public class HibernateTransaction extends AbstractHibernateTransaction
