/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
/* Generated by Together */

package it.eng.spago.dbaccess.sql.command.legacy;

import java.util.List;

import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.error.EMFInternalError;

/**
* Questa Classe rappresenta un comando SQL di DELETE per driver jdbc 1.0
*
* @author Andrea Zoppello 
* @version 1.0
*/
public class LegacyDeleteCommand extends SQLCommand {
    /**
    * Costruttore
    * @param <B>DataConnection</B> dataConnection - l'oggetto dataConnection legato al comando
    * @param <B>String</B> commandString - La Stringa rappresentante il comando
    */
    public LegacyDeleteCommand(DataConnection dataConnection, String commandString) {
        super(dataConnection, commandString);
    } //public LegacyDeleteCommand(DataConnection dataConnection, String commandString)

    /**
    * Questo metodo server per eseguire il comnado senza parametri
    * @return un oggetto di tipo  <B>DataResult</B> contente il risultato dell'esecuzione del comando
    * @throws <B>EMFInternalError</B> - Se si verifica qualche problema durante l'esecuzione del comando
    */
    public DataResult execute() throws EMFInternalError {
        return null;
    } //public DataResult execute()

    /**
    * Questo metodo serve per eseguire il comando con dei parametri di input
    * @param <B>List</B> inputParameters - una lista di  <B>DataField</B> object
    * @return un oggetto di tipo  <B>DataResult</B> contente il risultato dell'esecuzione del comando
    * @throws <B>EMFInternalError</B> - Se si verifica qualche problema durante l'esecuzione del comando
    */
    public DataResult execute(List inputParameters) throws EMFInternalError {
        return null;
    } //public DataResult execute(List inputParameters)
} //end Class LegacyDeleteCommand
