/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.sql.result;

import java.util.ArrayList;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import it.eng.spago.base.AbstractXMLObject;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanAttribute;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.error.EMFInternalError;

public class XMLScrollabelDataResult extends AbstractXMLObject {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private SourceBean _rowsBean = null;
    private boolean _asElement = false;
    private boolean _asCData = false;

    public XMLScrollabelDataResult(
        SourceBean rowsBean,
        boolean asElement,
        boolean asCData)
        throws EMFInternalError {
        super();
        _rowsBean = rowsBean;
        _asElement = asElement;
        _asCData = asCData;
        // navigazione sdr
    } // public XMLScrollabelDataResult(SourceBean rowsBean, boolean asElement, boolean asCData) throws EMFInternalError

    public Element toElement(Document document) {
        Element rowsElement =
            document.createElement(ScrollableDataResult.ROWS_TAG);
        ArrayList rowBeanVector = (ArrayList)_rowsBean.getAttributeAsList(DataRow.ROW_TAG);
        for (int i = 0; i < rowBeanVector.size(); i++) {
            Element rowElement = document.createElement(DataRow.ROW_TAG);
            SourceBean rowBean = (SourceBean) rowBeanVector.get(i);
            ArrayList columnBeanVector = (ArrayList)rowBean.getContainedAttributes();
            for (int j = 0; j < columnBeanVector.size(); j++) {
                SourceBeanAttribute columnBean =
                    (SourceBeanAttribute) columnBeanVector.get(j);
                if (!_asElement)
                    rowElement.setAttribute(
                        columnBean.getKey(),
                        columnBean.getValue().toString());
                else {
                    Element columnElement =
                        document.createElement(
                            columnBean.getKey().toUpperCase());
                    if (!_asCData)
                        columnElement.appendChild(
                            document.createTextNode(
                                columnBean.getValue().toString()));
                    else
                        columnElement.appendChild(
                            document.createCDATASection(
                                columnBean.getValue().toString()));
                    rowElement.appendChild(columnElement);
                } // if (!_asElement) else
            } // for (int j = 0; j < columnsBeanVector.size(); j++)
            rowsElement.appendChild(rowElement);
        } // for (int i = 0; i < _rows.size(); i++)
        return rowsElement;
    } // public Element toElement(Document document)
} // public class XMLScrollabelDataResult extends AbstractXMLObject
