/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dbaccess.test;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;

import java.math.BigDecimal;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;

public class TestInsert {
    public static void main(String[] args) {
        try {
            DataConnectionManager dcm = DataConnectionManager.getInstance();
            DataConnection dataConnection = dcm.getConnection();
            testFixedInsert(dataConnection);
            testVariableInsert(dataConnection);
            dataConnection.close();
        }
        catch (Exception eie) {
            eie.printStackTrace();
        } //end try-cath
    } // public static void main(String[] args)

    public static void testFixedInsert(DataConnection dc) {
        try {
            String queryString = "INSERT INTO TAB_PROVA(ID, DESCRIZIONE, DATA_INS, VALORE)  VALUES (10, 'valore 10',  TO_DATE('1900-01-01','YYYY-MM-DD') , 10.67)";
            SQLCommand insertCommand = dc.createInsertCommand(queryString);
            DataResult dr = insertCommand.execute();
            dr.getDataObject();
            System.out.println(" Eseguito comando e ottenuto result set.... continua ");
            insertCommand.close();
            System.out.println(" Effettuate le close continua ");
        }
        catch (Exception e) {
            e.printStackTrace();
        } //END IF
    } //public static void testFixedInsert(DataConnection dc)

    public static void testVariableInsert(DataConnection dc) {
        try {
            System.out.println(" Query Variabile Iniziata");
            String queryString = "INSERT INTO TAB_PROVA(ID, DESCRIZIONE, DATA_INS, VALORE)  VALUES (?, ?,  ? , ?)";
            SQLCommand insertCommand = dc.createInsertCommand(queryString);
            List inputParameters = new ArrayList();
            inputParameters.add(0, dc.createDataField("ID", Types.DECIMAL, new BigDecimal(15)));
            inputParameters.add(1, dc.createDataField("DESCRIZIONE", Types.VARCHAR, "valore Parametrico"));
            //inputParameters.add(2,dc.createDataField("DATA_INS",Types.TIMESTAMP,"10-12-2001"));
            inputParameters.add(2, dc.createDataField("DATA_INS", Types.TIMESTAMP, "10-12-2001 01:01:57"));
            inputParameters.add(3, dc.createDataField("VALORE", Types.DOUBLE, new Double(1.4)));
            DataResult dr = insertCommand.execute(inputParameters);
            System.out.println(" Comando di insert Eseguito");
            dr.getDataObject();
            System.out.println(" Eseguito comando e ottenuto result set.... continua ");
            insertCommand.close();
            System.out.println(" Effettuate le close continua ");
            String querySelect = "SELECT * FROM TAB_PROVA";
            SQLCommand selectCommand = dc.createSelectCommand(querySelect);
            ScrollableDataResult sdr = (ScrollableDataResult)selectCommand.execute().getDataObject();
            System.out.println((sdr.getSourceBean().toXML()));
            sdr.close();
            selectCommand.close();
            return;
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    } // public static void testVariableInsert(DataConnection dc)
}
