/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.dispatching.coordinator;

import java.util.ArrayList;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.init.InitializerIFace;
import it.eng.spago.tracing.TracerSingleton;

/**
* DATE            CONTRIBUTOR/DEVELOPER    NOTE
* 13-12-2004		  Butano	  SourceBean restituisce ArrayList
* 										    
**/

/**
 * @author 
 */
public class DispatcherInitializer implements InitializerIFace {
    private SourceBean _config = null;

    public DispatcherInitializer() {
        super();
        _config = null;
    } // public DispatcherInitializer()

    public void init(SourceBean config) {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.DEBUG, "DispatcherInitializer::init: config", config);
        _config = config;
        ConfigSingleton configure = ConfigSingleton.getInstance();
        ArrayList dispatchers = (ArrayList)configure.getAttributeAsList("DISPATCHERS.DISPATCHER");
        for (int i = 0; i < dispatchers.size(); i++) {
            try {
                SourceBean dispatcherBean = (SourceBean)dispatchers.get(i);
                String dispatcherClass = (String)dispatcherBean.getAttribute("CLASS");
                DispatcherIFace dispatcher = (DispatcherIFace)Class.forName(dispatcherClass).newInstance();
                DispatcherManager.registerDispatcher(dispatcher);
            } // try
            catch (Exception ex) {
                System.out.println("DispatcherInitializer::init: eccezione");
                ex.printStackTrace();
            } // catch (Excpetion ex) try
        } // for (int i = 0; i < dispatchers.size(); i++)
    } // public void init(SourceBean config)

    public SourceBean getConfig() {
        return _config;
    } // public SourceBean getConfig()
} // public class DispatcherInitializer implements InitializerIFace
