/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.event;

import java.util.Collection;
import java.util.HashMap;

import it.eng.spago.event.condition.EventConditionIFace;
import it.eng.spago.event.handler.EventHandlerIFace;

public class EventConditionsHandlers {
    private HashMap _eventConditionsHandlerRelations = null;

    public EventConditionsHandlers() {
        super();
        _eventConditionsHandlerRelations = new HashMap();
    } // public EventConditionsHandlers()

    public Collection getEventConditionsHandlerRelations() {
        return _eventConditionsHandlerRelations.values();
    } // public Collection getEventConditionsHandlerRelations()

    public void setEventConditionHandler(EventConditionIFace eventCondition, EventHandlerIFace eventHandler) {
        if ((eventCondition == null) || (eventHandler == null))
            return;
        EventConditionsHandlerRelation eventConditionsHandlerRelation =
            (EventConditionsHandlerRelation)_eventConditionsHandlerRelations.get(eventHandler.getKey());
        if (eventConditionsHandlerRelation == null) {
            eventConditionsHandlerRelation = new EventConditionsHandlerRelation();
            _eventConditionsHandlerRelations.put(eventHandler.getKey(), eventConditionsHandlerRelation);
            eventConditionsHandlerRelation.setEventHandler(eventHandler);
        } // if (!(_eventConditionsHandlerRelations.containsKey(eventHandler.getKey())))
        eventConditionsHandlerRelation.setEventCondition(eventCondition);
    } // public void setEventConditionHandler(EventConditionIFace
    // eventCondition, EventHandlerIFace eventHandler)
} // public class EventConditionsHandlers
