/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.event.handler;

import it.eng.spago.base.Constants;
import it.eng.spago.base.SourceBean;
import it.eng.spago.init.InitializerIFace;
import it.eng.spago.tracing.TracerSingleton;

public abstract class AbstractEventHandlerDriver implements InitializerIFace, EventHandlerDriverIFace {
    private SourceBean _config = null;

    public AbstractEventHandlerDriver() {
        super();
        _config = null;
    } // public AbstractEventHandlerDriver()

    public void init(SourceBean config) {
        _config = config;
    } // public void init(SourceBean config)

    public SourceBean getConfig() {
        return _config;
    } // public SourceBean getConfig()

    public boolean acceptsEventHandler(String eventHandlerKey) {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.WARNING,
            "AbstractEventHandlerDriver::acceptsEventHandler: servizio non implementato");
        return true;
    } // public boolean acceptsEventHandler(String eventHandlerKey)

    public EventHandlerIFace getEventHandler() {
        TracerSingleton.log(Constants.NOME_MODULO, TracerSingleton.WARNING,
            "AbstractEventHandlerDriver::getEventHandler: servizio non implementato");
        return null;
    } // public EventHandlerIFace getEventHandler()
} // public abstract class AbstractEventHandlerDriver implements InitializerIFace, EventHandlerDriverIFace
