/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.presentation;

import java.util.List;

import it.eng.spago.base.Constants;
import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.tracing.TracerSingleton;
import it.eng.spago.util.ContextScooping;

/**
* DATE            CONTRIBUTOR/DEVELOPER    NOTE
* 13-12-2004		  Butano           SourceBean ora restituisce ArrayList
* 										    
**/
/**
 * @author 
 */
public class DefaultPublisherDispatcher extends AbstractPublisherDispatcher {
    public DefaultPublisherDispatcher() {
        super();
    } // public DefaultPublisherDispatcher()

    public String getPublisherName(
        RequestContainer requestContainer,
        ResponseContainer responseContainer) {
        TracerSingleton.log(
            Constants.NOME_MODULO,
            TracerSingleton.DEBUG,
            "DefaultPublisherDispatcher::getPublisherName: config",
            getConfig());
        //Modifiche Monica 16/01/2004 - inizio
        //Interpreta la grammatica contenuta nella busta <CONFIG> dell'ITEM
        String targetName = null;
        List checks = getConfig().getAttributeAsList("CHECKS.CHECK");
        if (checks.size() == 0)
            TracerSingleton.log(
                Constants.NOME_MODULO,
                TracerSingleton.WARNING,
                "DefaultPublisherDispatcher::getPublisherName: nessun check trovato");
        for (int i = 0; i < checks.size(); i++) {
            SourceBean check = (SourceBean) checks.get(i);
            List conditions =
                check.getAttributeAsList("CONDITIONS.PARAMETER");
            if (conditions.size() == 0)
                TracerSingleton.log(
                    Constants.NOME_MODULO,
                    TracerSingleton.DEBUG,
                    "DefaultPublisherDispatcher::getPublisherName: nessuna condizione trovata");
            boolean conditionVerified = true;
            for (int j = 0; j < conditions.size(); j++) {
                SourceBean condition = (SourceBean) conditions.get(j);
                String parameterName = (String) condition.getAttribute("NAME");
                String parameterScope =
                    (String) condition.getAttribute("SCOPE");
                String parameterValue =
                    (String) condition.getAttribute("VALUE");
                String inParameterValue = null;
                Object parameterValueObject =
                    ContextScooping.getScopedParameter(
                        requestContainer,
                        responseContainer,
                        parameterName,
                        parameterScope);
                if (parameterValueObject != null)
                    inParameterValue = parameterValueObject.toString();
                if (parameterValue.equalsIgnoreCase("AF_DEFINED")) {
                    if (inParameterValue == null) {
                        conditionVerified = false;
                        break;
                    } // if (inParameterValue == null)
                    continue;
                } // if (parameterValue.equalsIgnoreCase("AF_DEFINED"))
                if (parameterValue.equalsIgnoreCase("AF_NOT_DEFINED")) {
                    if (inParameterValue != null) {
                        conditionVerified = false;
                        break;
                    } // if (inParameterValue != null)
                    continue;
                } // if (parameterValue.equalsIgnoreCase("AF_NOT_DEFINED"))
                if (!(parameterValue.equalsIgnoreCase(inParameterValue))) {
                    conditionVerified = false;
                    break;
                } // if (!(parameterValue.equalsIgnoreCase(inParameterValue)))
            } // for (int j = 0; conditions.size(); j++)
            if (conditionVerified) {
                //ATTRIBUTO TARGET DEFINISCE IL PUBLISHER DI DESTINAZIONE
                targetName = (String) check.getAttribute("TARGET");
                break;
            } // if (conditionVerified)
        } // for (int i = 0; i < checks.size(); i++)        
        return targetName;
        //      Modifiche Monica 16/01/2004 - fine
    } // public String getPublisherName(RequestContainer requestContainer, ResponseContainer responseContainer)
} // public class DefaultPublisherDispatcher extends AbstractPublisherDispatcher
