/**

    Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

    This file is part of Spago.

    Spago is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    any later version.

    Spago is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Spago; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.security;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.error.EMFInternalError;

/**
 * @author zoppello
 *
 * Questa interfaccia deve essere implementata dalla classe che effettua il
 * collegamento tra il sistema di autenticazione e il sistema di autorizzazione
 */
public interface IAuthorizationHandler {
    /**
     * Method putAuhtorizationProfile.
     * @param userIdentifier - Il token fornito dal sistema di Autenticazione
     * @param requestConatiner - L'oggetto request container dell'application
     * framework
     * @throws EMFInternalError
     */
    public void putAuhtorizationProfile(Object userIdentifier, RequestContainer requestConatiner) throws EMFInternalError;
}
