/**

Copyright 2004, 2005 Engineering Ingegneria Informatica S.p.A. & Sinapsi S.p.A.

This file is part of Spago.

Spago is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
any later version.

Spago is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with Spago; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago.tags;

import java.text.SimpleDateFormat;
import java.util.Locale;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class StringWriterTag extends TagSupport 
{
	
  /**
     * 
     */
    private static final long serialVersionUID = 1L;
private static SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yyyy", Locale.ITALY);
		
  public StringWriterTag()
  {}

  public void setString(String stringToWrite)
  { this.stringToWrite = stringToWrite; }

  public void setString(Integer intToWrite)
  { this.stringToWrite = (intToWrite != null) ? intToWrite.toString(): nullValue; }
  
  public void setString(Long longToWrite)
  { this.stringToWrite = (longToWrite != null) ? longToWrite.toString(): nullValue; }
  
  public void setString(Double dblToWrite)
	{ this.stringToWrite = (dblToWrite != null) ? dblToWrite.toString(): nullValue; }

  public void setString(java.util.Date dateToWrite)
	{ this.stringToWrite = (dateToWrite != null) ? formatter.format(dateToWrite): nullValue; }
  
  
  public String getString()
  { return stringToWrite; }

  public void setEncode(boolean encode)
  { this.encode = encode; }
  
  public boolean getEncode()
  { return encode; }
  
  public void setNullValue(String nullValue)
  { this.nullValue = nullValue; }
  
  public String getNullValue()
  { return nullValue; }

  public int doStartTag() throws JspException {
    try {
      String outputStr = "";
      if(encode){
        outputStr = (stringToWrite != null) ? escapeForHtml(stringToWrite) : nullValue;
      }else{
        outputStr = (stringToWrite != null) ? stringToWrite : nullValue;
      }
      pageContext.getOut().print(outputStr);
    }
    catch (java.io.IOException e)
    {
      throw new JspException(e.getMessage());
    }
    return SKIP_BODY;
  }

  public int doEndTag() throws JspException  {
    encode = true;
    return EVAL_PAGE;
  }

  public String escapeForHtml(String value)
  {
    StringBuffer buffer = new StringBuffer();
    for (int i = 0; i < value.length(); i++) {
      char ch = value.charAt(i);
      if ((int)ch == 10)
        buffer.append("<br>");
      // TCKINT00519 - Campi descrittivi con virgolette (") INIZIO
      else if (ch < ' ' || ch > '~' || ch == '<' || ch == '>' || ch == '&' || ch == '"') {
      // TCKINT00519 - Campi descrittivi con virgolette (") FINE
        buffer.append("&#");
        buffer.append((int) ch);
        buffer.append(";");
      } else
        buffer.append(ch);
    }
    value = buffer.toString();
    return value;
  }

  private String nullValue = "";
  private String stringToWrite = null;
  private boolean encode = true;
}
